//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Silver
#property  indicator_color2  Red
#property  indicator_color3  DarkViolet
#property  indicator_color4  Yellow
#property  indicator_width1  2
//---- indicator parameters
extern int FastEMA1=12;
extern int SlowEMA1=26;
extern int SignalSMA1=9;
extern int FastEMA2=12;
extern int SlowEMA2=26;
extern int SignalSMA2=9;
extern int PERIOD1 =1;
extern int PERIOD2 =5;
extern int LengthSample=500;    //      .
static datetime prevtime1=0;
static datetime prevtime2=0;
double IMA[],SMA[],MB2[],SB2[];
//---- indicator buffers
double     MacdBuffer1[];
double     SignalBuffer1[];
double     MacdBuffer2[];
double     SignalBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SignalSMA1);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexDrawBegin(3,LengthSample);
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer1);
   SetIndexBuffer(1,SignalBuffer1);
   SetIndexBuffer(2,MacdBuffer2);
   SetIndexBuffer(3,SignalBuffer2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("MACD_2TF("+FastEMA1+","+SlowEMA1+","+SignalSMA1+","+FastEMA2+","+SlowEMA2+","+SignalSMA2+")");
   SetIndexLabel(0,"MACD");
   SetIndexLabel(1,"Signal");

   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
      for(int i=0; i<limit; i++){
         MacdBuffer1[i]=iMA(NULL,PERIOD1,FastEMA1,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,PERIOD1,SlowEMA1,0,MODE_EMA,PRICE_CLOSE,i);
      }         
      for(i=0; i<limit; i++){
         SignalBuffer1[i]=iMAOnArray(MacdBuffer1,0,SignalSMA1,0,MODE_SMA,i);
      }         
      for(i=0; i<=LengthSample; i++){
         MacdBuffer2[i]=iMA(NULL,PERIOD2,FastEMA2,0,MODE_EMA,PRICE_OPEN,i)-iMA(NULL,PERIOD2,SlowEMA2,0,MODE_EMA,PRICE_OPEN,i);
      }    
      for(i=LengthSample;i>=0;i--){
         SignalBuffer2[i]=iMAOnArray(MacdBuffer2,0,SignalSMA2,0,MODE_SMA,i);  
      }         
  
   Comment(" IMA = "," ", DoubleToStr(IMA[1],5)) ;     
   return(0);
}

